/*
 * Registers definition for NM FGPA
 *
 * Copyright 2018 NetModule AG.
 *
 * Author: Alexandre Bard, Netmodule AG
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 */

#ifndef _NM_FPGA_REG_H
#define	_NM_FPGA_REG_H

/* Registers definition */
#define NM_FPGA_REG_ID            0x0
#define NM_FPGA_REG_VER           0x2
#define NM_FPGA_REG_SCRATCH       0x4
#define NM_FPGA_REG_STATUS1       0x6
#define NM_FPGA_REG_STATUS2       0x8

#define NM_FPGA_REG_INT_MASK1     0x10
#define NM_FPGA_REG_INT_MASK2     0x12
#define NM_FPGA_REG_INT_PENDING1  0x14
#define NM_FPGA_REG_INT_PENDING2  0x16
#define NM_FPGA_REG_INT_STAT_ACK1 0x18
#define NM_FPGA_REG_INT_STAT_ACK2 0x1A

#define NM_FPGA_REG_LEDS          0x20

#define NM_FPGA_REG_SERIAL_CTRL   0x24

#define NM_FPGA_REG_PCIE_RST      0x30
#define NM_FPGA_REG_PCIE_PWR      0x32
#define NM_FPGA_REG_PCIE_CLK_EN   0x34
#define NM_FPGA_REG_PCIE_I2C      0x36
#define NM_FPGA_REG_PCIE_PGOOD    0x38
#define NM_FPGA_REG_PCIE_PWR_UP   0x3A

#define NM_FPGA_REG_SIM_CTRL      0x40

#define NM_FPGA_REG_SFP_BASE	0x74
#define NM_FPGA_REG_SFP_STATUS	(NM_FPGA_REG_SFP_BASE + 0x00)
#define NM_FPGA_REG_SFP_CTRL	(NM_FPGA_REG_SFP_BASE + 0x02)

// FPGA Register Slot Base Addresses
#define NM_FPGA_REG_SLOT_PCIE1		0x100
#define NM_FPGA_REG_SLOT_PCIE2		0x200
#define NM_FPGA_REG_SLOT_EXT		0x300
#define NM_FPGA_REG_SLOT_LOWEXT1	0x400
#define NM_FPGA_REG_SLOT_LOWEXT2	0x500

// FPGA Register Slot Offsets
#define NM_FPGA_REG_PCIE_SLOT_DIR	0x00
#define NM_FPGA_REG_PCIE_SLOT_CTRL	0x02
#define NM_FPGA_REG_PCM_IOMUX		0x04
#define NM_FPGA_REG_PCM_ID		0x06
#define NM_FPGA_REG_PCM_VCTL		0x10
#define NM_FPGA_REG_PCM_VRDB		0x12
#define NM_FPGA_REG_PCM_VRBW		0x16
#define NM_FPGA_REG_PCM_VRIS		0x18
#define NM_FPGA_REG_PCM_VTDB		0x1A
#define NM_FPGA_REG_PCM_VTBFL		0x1C
#define NM_FPGA_REG_PCM_VTIS		0x20
#define NM_FPGA_REG_PCM_VTBW		0x1E
#define NM_FPGA_REG_PCM_GPIO_EN		0x30
#define NM_FPGA_REG_PCM_GPIO_DIR	0x32
#define NM_FPGA_REG_PCM_GPIO_DATA	0x34
#define NM_FPGA_REG_EXTSLOT_GPIO_IN	0x40
#define NM_FPGA_REG_EXTSLOT_GPIO_OUT	0x42
#define NM_FPGA_REG_EXTSLOT_GPIO_DIR	0x44

#define NM_FPGA_REG_PCIE1_DIR1    0x100
#define NM_FPGA_REG_PCIE1_CTRL1   0x102
#define NM_FPGA_REG_PCIE_PCM_CTRL1 0x104
#define NM_FPGA_REG_PCIE_PCM_ID1  0x106
#define NM_FPGA_REG_PCIE_PCM_CTL1 0x110
#define NM_FPGA_REG_VOICE_RX_DAT1 0x112
#define NM_FPGA_REG_VOICE_RX_LVL1 0x114
#define NM_FPGA_REG_VOICE_RX_WM1  0x116
#define NM_FPGA_REG_VOICE_RX_IDLE1 0x118
#define NM_FPGA_REG_VOICE_TX_DAT1 0x11A
#define NM_FPGA_REG_VOICE_TX_LVL1 0x11C
#define NM_FPGA_REG_VOICE_TX_WM1  0x11E
#define NM_FPGA_REG_VOICE_TX_IDLE1 0x120

#define NM_FPGA_REG_PCMI_GPIO_EN1  0x130
#define NM_FPGA_REG_PCMI_GPIO_DIR1 0x132
#define NM_FPGA_REG_PCMI_GPIO_DAT1 0x134
#define NM_FPGA_REG_PCIE_VV_CTRL1  0x138

#define NM_FPGA_REG_PCIE2_BASE    0x200
#define NM_FPGA_REG_PCIE2_DIR1    (NM_FPGA_REG_PCIE2_BASE + NM_FPGA_REG_DIR_OFFSET)
#define NM_FPGA_REG_PCIE2_CTRL1   (NM_FPGA_REG_PCIE2_BASE + NM_FPGA_REG_PCIE_SLOT_CTRL)
#define NM_FPGA_REG_PCIE_PCM_CTRL2 0x204
#define NM_FPGA_REG_PCIE_PCM_ID2  0x206
#define NM_FPGA_REG_PCIE_PCM_CTL2 0x210
#define NM_FPGA_REG_VOICE_RX_DAT2 0x212
#define NM_FPGA_REG_VOICE_RX_LVL2 0x214
#define NM_FPGA_REG_VOICE_RX_WM2  0x216
#define NM_FPGA_REG_VOICE_RX_IDLE2 0x218
#define NM_FPGA_REG_VOICE_TX_DAT2 0x21A
#define NM_FPGA_REG_VOICE_TX_LVL2 0x21C
#define NM_FPGA_REG_VOICE_TX_WM2  0x21E
#define NM_FPGA_REG_VOICE_TX_IDLE2 0x220

#define NM_FPGA_REG_PCMI_GPIO_EN2  0x230
#define NM_FPGA_REG_PCMI_GPIO_DIR2 0x232
#define NM_FPGA_REG_PCMI_GPIO_DAT2 0x234
#define NM_FPGA_REG_PCIE_VV_CTRL2  0x238

#define NM_FPGA_REG_EXT_DIR1      0x300
#define NM_FPGA_REG_EXT_CTRL1     0x302
#define NM_FPGA_REG_PCIE_PCM_CTRL3  0x304
#define NM_FPGA_REG_PCIE_PCM_ID3  0x306
#define NM_FPGA_REG_PCIE_PCM_CTL3 0x310
#define NM_FPGA_REG_VOICE_RX_DAT3 0x312
#define NM_FPGA_REG_VOICE_RX_LVL3 0x314
#define NM_FPGA_REG_VOICE_RX_WM3  0x316
#define NM_FPGA_REG_VOICE_RX_IDLE3 0x318
#define NM_FPGA_REG_VOICE_TX_DAT3 0x31A
#define NM_FPGA_REG_VOICE_TX_LVL3 0x31C
#define NM_FPGA_REG_VOICE_TX_WM3  0x31E
#define NM_FPGA_REG_VOICE_TX_IDLE3 0x320

#define NM_FPGA_REG_PCMI_GPIO_EN3  0x330
#define NM_FPGA_REG_PCMI_GPIO_DIR3 0x332
#define NM_FPGA_REG_PCMI_GPIO_DAT3 0x334
#define NM_FPGA_REG_PCIE_PULL_UP3  0x338

#define NM_FPGA_REG_EXT_GPIO_IN   0x340
#define NM_FPGA_REG_EXT_GPIO_OUT  0x342
#define NM_FPGA_REG_EXT_GPIO_DIR  0x344

#define NM_FPGA_REG_LOW_EXT1_DIR  0x400
#define NM_FPGA_REG_LOW_EXT1_CTRL 0x402
#define NM_FPGA_REG_LOW_EXT1_PULLUP 0x438

#define NM_FPGA_REG_LOW_EXT2_DIR  0x500
#define NM_FPGA_REG_LOW_EXT2_CTRL 0x502
#define NM_FPGA_REG_LOW_EXT2_PULLUP 0x538

/* Bit definitions */
#define NM_FPGA_BIT_SIM1_CD        10
#define NM_FPGA_BIT_SIM2_CD        11
#define NM_FPGA_BIT_SD_CD          12
#define NM_FPGA_BIT_ETH1_IRQ       14
#define NM_FPGA_BIT_ETH2_IRQ       15

#define NM_FPGA_BIT_EN_5V0_INT      0
#define NM_FPGA_BIT_SD_EN           1
#define NM_FPGA_BIT_GPS_PWR_EN      2

#define NM_FPGA_BIT_PCIE1_RST       0
#define NM_FPGA_BIT_PCIE2_RST       1
#define NM_FPGA_BIT_EXT_RST         2
#define NM_FPGA_BIT_LOWEXT1_RST     3
#define NM_FPGA_BIT_LOWEXT2_RST     4
#define NM_FPGA_BIT_SFP_RST         5

#define NM_FPGA_BIT_PCIE1_PWR       0
#define NM_FPGA_BIT_PCIE2_PWR       1
#define NM_FPGA_BIT_EXT_PWR         2
#define NM_FPGA_BIT_LOWEXT1_PWR     3
#define NM_FPGA_BIT_LOWEXT2_PWR     4
#define NM_FPGA_BIT_SFP_PWR         5

#define NM_FPGA_BIT_RX_LOS          0
#define NM_FPGA_BIT_PRESENT         1
#define NM_FPGA_BIT_TX_FAULT        2
#define NM_FPGA_BIT_PWR_FAULT       3
#define NM_FPGA_BIT_TX_DIS          0

#define NM_FPGA_BIT_SIM1_SEL0       0
#define NM_FPGA_BIT_SIM1_SEL1       1
#define NM_FPGA_BIT_SIM1_SEL2       2
#define NM_FPGA_BIT_SIM2_SEL0       3
#define NM_FPGA_BIT_SIM2_SEL1       4
#define NM_FPGA_BIT_SIM2_SEL2       5

#define NM_FPGA_BIT_RS232_EN        0
#define NM_FPGA_BIT_RS485_EN        1
#define NM_FPGA_BIT_RS485_TERM      2

#define NM_FPGA_BIT_PCIE_COEX1      0
#define NM_FPGA_BIT_PCIE_COEX2      1
#define NM_FPGA_BIT_PCIE_LED_WLAN   2
#define NM_FPGA_BIT_PCIE_LED_WWAN   3
#define NM_FPGA_BIT_PCIE_WAKE       4
#define NM_FPGA_BIT_PCIE_WDISABLE   5

#define NM_FPGA_BIT_PCIE1_PWR_UP    0
#define NM_FPGA_BIT_PCIE2_PWR_UP    1
#define NM_FPGA_BIT_LOWEXT1_PWR_UP  3

#define NM_FPGA_BIT_PCM_EN          0
#define NM_FPGA_BIT_LOOP            1

#define NM_FPGA_BIT_RST_1V8         0
#define NM_FPGA_BIT_RST_3V3         1
#define NM_FPGA_BIT_WDISABLE_1V8    2
#define NM_FPGA_BIT_WDISABLE_3V3    3

#endif /* _NM_FPGA_REG_H */
